#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
test_phones
----------------------------------

Tests for `validus` module.
"""

import unittest
import validus


class TestPhones(unittest.TestCase):

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def test_isphone(self):
        self.assertTrue(validus.isphone('+963944549710', 'ar-SY'))
        self.assertTrue(validus.isphone('956654379', 'ar-SY'))
        self.assertTrue(validus.isphone('0962655597', 'ar-SY'))
        self.assertFalse(validus.isphone('12345', 'ar-SY'))
        self.assertFalse(validus.isphone('+9639626626262', 'ar-SY'))
        self.assertFalse(validus.isphone('+963332210972', 'ar-SY'))

        self.assertTrue(validus.isphone('+966556578654', 'ar-SA'))
        self.assertTrue(validus.isphone('596578654', 'ar-SA'))
        self.assertTrue(validus.isphone('0556578654', 'ar-SA'))
        self.assertFalse(validus.isphone('12345', 'ar-SA'))
        self.assertFalse(validus.isphone('+9665626626262', 'ar-SA'))
        self.assertFalse(validus.isphone('0114152198', 'ar-SA'))

        self.assertTrue(validus.isphone('+420123456789', 'cs-CZ'))
        self.assertTrue(validus.isphone('+420 123456789', 'cs-CZ'))
        self.assertFalse(validus.isphone('+42012345678', 'cs-CZ'))

        self.assertTrue(validus.isphone('+49 (0) 123 456 789', 'de-DE'))
        self.assertTrue(validus.isphone('+49 (0) 123 456789', 'de-DE'))
        self.assertFalse(validus.isphone('Vml2YW11cyBmZXJtZtesting123', 'de-DE'))

        self.assertTrue(validus.isphone('55-17-3332-2155', 'pt-BR'))
        self.assertTrue(validus.isphone('551223456789', 'pt-BR'))
        self.assertTrue(validus.isphone('55-15-25661234', 'pt-BR'))
        self.assertTrue(validus.isphone('+55-12-996551215', 'pt-BR'))
        self.assertFalse(validus.isphone('+017-123456789', 'pt-BR'))
        self.assertFalse(validus.isphone('5501599623874', 'pt-BR'))
        self.assertFalse(validus.isphone('+55-015-1234-3214', 'pt-BR'))

        self.assertTrue(validus.isphone('15323456787', 'zh-CN'))
        self.assertTrue(validus.isphone('13523333233', 'zh-CN'))
        self.assertTrue(validus.isphone('86-17823492338', 'zh-CN'))
        self.assertTrue(validus.isphone('+086-13238234822', 'zh-CN'))
        self.assertFalse(validus.isphone('12345', 'zh-CN'))
        self.assertFalse(validus.isphone('Vml2YW11cyBmZXJtZtesting123', 'zh-CN'))
        self.assertFalse(validus.isphone('010-38238383', 'zh-CN'))

        self.assertTrue(validus.isphone('0987123456', 'zh-TW'))
        self.assertTrue(validus.isphone('+886987123456', 'zh-TW'))
        self.assertTrue(validus.isphone('886987123456', 'zh-TW'))
        self.assertTrue(validus.isphone('+886-987123456', 'zh-TW'))
        self.assertTrue(validus.isphone('886-987123456', 'zh-TW'))
        self.assertFalse(validus.isphone('Vml2YW11cyBmZXJtZtesting123', 'zh-TW'))
        self.assertFalse(validus.isphone('0-987123456', 'zh-TW'))
        self.assertFalse(validus.isphone('12345', 'zh-TW'))

        self.assertTrue(validus.isphone('0821231234', 'en-ZA'))
        self.assertTrue(validus.isphone('+27821231234', 'en-ZA'))
        self.assertTrue(validus.isphone('27821231234', 'en-ZA'))
        self.assertFalse(validus.isphone('082123', 'en-ZA'))
        self.assertFalse(validus.isphone('08212312345', 'en-ZA'))
        self.assertFalse(validus.isphone('21821231234', 'en-ZA'))
        self.assertFalse(validus.isphone('+21821231234', 'en-ZA'))
        self.assertFalse(validus.isphone('+0821231234', 'en-ZA'))

        self.assertTrue(validus.isphone('61404111222', 'en-AU'))
        self.assertTrue(validus.isphone('+61411222333', 'en-AU'))
        self.assertTrue(validus.isphone('0417123456', 'en-AU'))
        self.assertFalse(validus.isphone('082123', 'en-AU'))
        self.assertFalse(validus.isphone('08212312345', 'en-AU'))
        self.assertFalse(validus.isphone('21821231234', 'en-AU'))
        self.assertFalse(validus.isphone('+21821231234', 'en-AU'))
        self.assertFalse(validus.isphone('+0821231234', 'en-AU'))
        self.assertFalse(validus.isphone('04123456789', 'en-AU'))

        self.assertTrue(validus.isphone('91234567', 'en-HK'))
        self.assertTrue(validus.isphone('9123-4567', 'en-HK'))
        self.assertTrue(validus.isphone('61234567', 'en-HK'))
        self.assertTrue(validus.isphone('51234567', 'en-HK'))
        self.assertTrue(validus.isphone('+85291234567', 'en-HK'))
        self.assertTrue(validus.isphone('+852-91234567', 'en-HK'))
        self.assertTrue(validus.isphone('+852-9123-4567', 'en-HK'))
        self.assertTrue(validus.isphone('852-91234567', 'en-HK'))
        self.assertFalse(validus.isphone('999', 'en-HK'))
        self.assertFalse(validus.isphone('+852-912345678', 'en-HK'))
        self.assertFalse(validus.isphone('123456789', 'en-HK'))
        self.assertFalse(validus.isphone('+852-1234-56789', 'en-HK'))

        self.assertTrue(validus.isphone('0612457898', 'fr-FR'))
        self.assertTrue(validus.isphone('+33612457898', 'fr-FR'))
        self.assertTrue(validus.isphone('33612457898', 'fr-FR'))
        self.assertTrue(validus.isphone('0712457898', 'fr-FR'))
        self.assertTrue(validus.isphone('+33712457898', 'fr-FR'))
        self.assertTrue(validus.isphone('33712457898', 'fr-FR'))
        self.assertFalse(validus.isphone('0512457898', 'fr-FR'))
        self.assertFalse(validus.isphone('0812457898', 'fr-FR'))
        self.assertFalse(validus.isphone('0912457898', 'fr-FR'))
        self.assertFalse(validus.isphone('+34612457898', 'fr-FR'))
        self.assertFalse(validus.isphone('+336124578980', 'fr-FR'))
        self.assertFalse(validus.isphone('+3361245789', 'fr-FR'))

        self.assertTrue(validus.isphone('+306944848966', 'el-GR'))
        self.assertTrue(validus.isphone('6944848966', 'el-GR'))
        self.assertTrue(validus.isphone('306944848966', 'el-GR'))
        self.assertFalse(validus.isphone('20000000000', 'el-GR'))
        self.assertFalse(validus.isphone('68129485729', 'el-GR'))
        self.assertFalse(validus.isphone('6589394827', 'el-GR'))
        self.assertFalse(validus.isphone('298RI89572', 'el-GR'))

        self.assertTrue(validus.isphone('447789345856', 'en-GB'))
        self.assertTrue(validus.isphone('+447861235675', 'en-GB'))
        self.assertTrue(validus.isphone('07888814488', 'en-GB'))
        self.assertFalse(validus.isphone('442073456754', 'en-GB'))
        self.assertFalse(validus.isphone('+443003434751', 'en-GB'))
        self.assertFalse(validus.isphone('05073456754', 'en-GB'))
        self.assertFalse(validus.isphone('08001123123', 'en-GB'))

        self.assertTrue(validus.isphone('19876543210', 'en-US'))
        self.assertTrue(validus.isphone('8005552222', 'en-US'))
        self.assertTrue(validus.isphone('+15673628910', 'en-US'))
        self.assertFalse(validus.isphone('+10345672645', 'en-US'))
        self.assertFalse(validus.isphone('11435213543', 'en-US'))
        self.assertFalse(validus.isphone('2436119753', 'en-US'))
        self.assertFalse(validus.isphone('16532116190', 'en-US'))

        self.assertTrue(validus.isphone('19876543210', 'en-CA'))
        self.assertTrue(validus.isphone('8005552222', 'en-CA'))
        self.assertTrue(validus.isphone('+15673628910', 'en-CA'))
        self.assertFalse(validus.isphone('+10345672645', 'en-CA'))
        self.assertFalse(validus.isphone('11435213543', 'en-CA'))
        self.assertFalse(validus.isphone('2436119753', 'en-CA'))
        self.assertFalse(validus.isphone('16532116190', 'en-CA'))

        self.assertTrue(validus.isphone('0956684590', 'en-ZM'))
        self.assertTrue(validus.isphone('0966684590', 'en-ZM'))
        self.assertTrue(validus.isphone('0976684590', 'en-ZM'))
        self.assertTrue(validus.isphone('+260956684590', 'en-ZM'))
        self.assertTrue(validus.isphone('+260966684590', 'en-ZM'))
        self.assertTrue(validus.isphone('+260976684590', 'en-ZM'))
        self.assertTrue(validus.isphone('260976684590', 'en-ZM'))
        self.assertFalse(validus.isphone('Vml2YW11cyBmZXJtZtesting123', 'en-ZM'))
        self.assertFalse(validus.isphone('010-38238383', 'en-ZM'))
        self.assertFalse(validus.isphone('966684590', 'en-ZM'))

        self.assertTrue(validus.isphone('+79676338855', 'ru-RU'))
        self.assertTrue(validus.isphone('79676338855', 'ru-RU'))
        self.assertTrue(validus.isphone('89676338855', 'ru-RU'))
        self.assertTrue(validus.isphone('9676338855', 'ru-RU'))
        self.assertFalse(validus.isphone('+9676338855', 'ru-RU'))
        self.assertFalse(validus.isphone('19676338855', 'ru-RU'))
        self.assertFalse(validus.isphone('6676338855', 'ru-RU'))
        self.assertFalse(validus.isphone('+99676338855', 'ru-RU'))

        self.assertTrue(validus.isphone('0640133338', 'sr-RS'))
        self.assertTrue(validus.isphone('063333133', 'sr-RS'))
        self.assertTrue(validus.isphone('0668888878', 'sr-RS'))
        self.assertTrue(validus.isphone('+381645678912', 'sr-RS'))
        self.assertTrue(validus.isphone('+381611314000', 'sr-RS'))
        self.assertTrue(validus.isphone('0655885010', 'sr-RS'))
        self.assertFalse(validus.isphone('Vml2YW11cyBmZXJtZtesting123', 'sr-RS'))
        self.assertFalse(validus.isphone('010-38238383', 'sr-RS'))
        self.assertFalse(validus.isphone('+9676338855', 'sr-RS'))
        self.assertFalse(validus.isphone('19676338855', 'sr-RS'))
        self.assertFalse(validus.isphone('6676338855', 'sr-RS'))
        self.assertFalse(validus.isphone('+99676338855', 'sr-RS'))

        self.assertTrue(validus.isphone('+6427987035', 'en-NZ'))
        self.assertTrue(validus.isphone('642240512347', 'en-NZ'))
        self.assertTrue(validus.isphone('0293981646', 'en-NZ'))
        self.assertTrue(validus.isphone('029968425', 'en-NZ'))
        self.assertFalse(validus.isphone('+642956696123566', 'en-NZ'))
        self.assertFalse(validus.isphone('+02119620856', 'en-NZ'))
        self.assertFalse(validus.isphone('+9676338855', 'en-NZ'))
        self.assertFalse(validus.isphone('19676338855', 'en-NZ'))

        self.assertTrue(validus.isphone('+4796338855', 'nb-NO'))
        self.assertTrue(validus.isphone('+4746338855', 'nb-NO'))
        self.assertTrue(validus.isphone('4796338855', 'nb-NO'))
        self.assertTrue(validus.isphone('4746338855', 'nb-NO'))
        self.assertFalse(validus.isphone('+4676338855', 'nb-NO'))
        self.assertFalse(validus.isphone('19676338855', 'nb-NO'))
        self.assertFalse(validus.isphone('+4726338855', 'nb-NO'))
        self.assertFalse(validus.isphone('4736338855', 'nb-NO'))

        self.assertTrue(validus.isphone('01636012403', 'vi-VN'))
        self.assertTrue(validus.isphone('+841636012403', 'vi-VN'))
        self.assertTrue(validus.isphone('1636012403', 'vi-VN'))
        self.assertTrue(validus.isphone('841636012403', 'vi-VN'))
        self.assertFalse(validus.isphone('Vml2YW11cyBmZXJtZtesting123', 'vi-VN'))
        self.assertFalse(validus.isphone('010-38238383', 'vi-VN'))
        self.assertFalse(validus.isphone('260976684590', 'vi-VN'))

        self.assertTrue(validus.isphone('+34654789321', 'es-ES'))
        self.assertTrue(validus.isphone('654789321', 'es-ES'))
        self.assertTrue(validus.isphone('+34714789321', 'es-ES'))
        self.assertTrue(validus.isphone('714789321', 'es-ES'))
        self.assertTrue(validus.isphone('+34744789321', 'es-ES'))
        self.assertFalse(validus.isphone('+3465478932', 'es-ES'))
        self.assertFalse(validus.isphone('65478932', 'es-ES'))
        self.assertFalse(validus.isphone('+346547893210', 'es-ES'))
        self.assertFalse(validus.isphone('6547893210', 'es-ES'))
        self.assertFalse(validus.isphone('+34704789321', 'es-ES'))

        self.assertTrue(validus.isphone('+48512689767', 'pl-PL'))
        self.assertTrue(validus.isphone('+48 56 376 87 47', 'pl-PL'))
        self.assertTrue(validus.isphone('56 566 78 46', 'pl-PL'))
        self.assertTrue(validus.isphone('657562855', 'pl-PL'))
        self.assertTrue(validus.isphone('+48657562855', 'pl-PL'))
        self.assertFalse(validus.isphone('+48  67 621 5461', 'pl-PL'))
        self.assertFalse(validus.isphone('+55657562855', 'pl-PL'))
        self.assertFalse(validus.isphone('3454535', 'pl-PL'))

        self.assertTrue(validus.isphone('+358505557171', 'fi-FI'))
        self.assertTrue(validus.isphone('0455571', 'fi-FI'))
        self.assertTrue(validus.isphone('0505557171', 'fi-FI'))
        self.assertTrue(validus.isphone('358505557171', 'fi-FI'))
        self.assertTrue(validus.isphone('04412345', 'fi-FI'))
        self.assertFalse(validus.isphone('010-38238383', 'fi-FI'))
        self.assertFalse(validus.isphone('+3-585-0555-7171', 'fi-FI'))
        self.assertFalse(validus.isphone('+9676338855', 'fi-FI'))
        self.assertFalse(validus.isphone('19676338855', 'fi-FI'))
        self.assertFalse(validus.isphone('6676338855', 'fi-FI'))

        self.assertTrue(validus.isphone('+60128228789', 'ms-MY'))
        self.assertTrue(validus.isphone('+60195830837', 'ms-MY'))
        self.assertTrue(validus.isphone('+6019-5830837', 'ms-MY'))
        self.assertTrue(validus.isphone('+6019-5830837', 'ms-MY'))
        self.assertFalse(validus.isphone('601238788657', 'ms-MY'))
        self.assertFalse(validus.isphone('088387675', 'ms-MY'))
        self.assertFalse(validus.isphone('16-2838768', 'ms-MY'))
        self.assertFalse(validus.isphone('032551433', 'ms-MY'))

        self.assertTrue(validus.isphone('0312345678', 'ja-JP'))
        self.assertTrue(validus.isphone('0721234567', 'ja-JP'))
        self.assertTrue(validus.isphone('09012345688', 'ja-JP'))
        self.assertTrue(validus.isphone('06 1234 5678', 'ja-JP'))
        self.assertTrue(validus.isphone('072 123 4567', 'ja-JP'))
        self.assertFalse(validus.isphone('+3-585-0555-7171', 'ja-JP'))
        self.assertFalse(validus.isphone('0 1234 5689', 'ja-JP'))
        self.assertFalse(validus.isphone('16 1234 5689', 'ja-JP'))
        self.assertFalse(validus.isphone('03_1234_5689', 'ja-JP'))

        self.assertTrue(validus.isphone('370 3175423', 'it-IT'))
        self.assertTrue(validus.isphone('333202925', 'it-IT'))
        self.assertTrue(validus.isphone('+39 310 7688449', 'it-IT'))
        self.assertTrue(validus.isphone('+39 3339847632', 'it-IT'))
        self.assertFalse(validus.isphone('011 7387545', 'it-IT'))
        self.assertFalse(validus.isphone('12345', 'it-IT'))
        self.assertFalse(validus.isphone('+45 345 6782395', 'it-IT'))

        self.assertTrue(validus.isphone('0470123456', 'fr-BE'))
        self.assertTrue(validus.isphone('+32470123456', 'fr-BE'))
        self.assertTrue(validus.isphone('32470123456', 'fr-BE'))
        self.assertTrue(validus.isphone('021234567', 'fr-BE'))
        self.assertTrue(validus.isphone('+3221234567', 'fr-BE'))
        self.assertFalse(validus.isphone('+3212345', 'fr-BE'))
        self.assertFalse(validus.isphone('3212345', 'fr-BE'))
        self.assertFalse(validus.isphone('04701234567', 'fr-BE'))
        self.assertFalse(validus.isphone('+3204701234567', 'fr-BE'))
        self.assertFalse(validus.isphone('3204701234567', 'fr-BE'))

        self.assertTrue(validus.isphone('0470123456', 'nl-BE'))
        self.assertTrue(validus.isphone('+32470123456', 'nl-BE'))
        self.assertTrue(validus.isphone('32470123456', 'nl-BE'))
        self.assertTrue(validus.isphone('021234567', 'nl-BE'))
        self.assertTrue(validus.isphone('+3221234567', 'nl-BE'))
        self.assertFalse(validus.isphone('+3212345', 'nl-BE'))
        self.assertFalse(validus.isphone('3212345', 'nl-BE'))
        self.assertFalse(validus.isphone('04701234567', 'nl-BE'))
        self.assertFalse(validus.isphone('+3204701234567', 'nl-BE'))

        self.assertTrue(validus.isphone('+40740123456', 'ro-RO'))
        self.assertTrue(validus.isphone('+40 740123456', 'ro-RO'))
        self.assertTrue(validus.isphone('+40740 123 456', 'ro-RO'))
        self.assertTrue(validus.isphone('+40740.123.456', 'ro-RO'))
        self.assertTrue(validus.isphone('+40740-123-456', 'ro-RO'))
        self.assertTrue(validus.isphone('0740 123 456', 'ro-RO'))
        self.assertTrue(validus.isphone('0740.123.456', 'ro-RO'))
        self.assertTrue(validus.isphone('0740-123-456', 'ro-RO'))
        self.assertFalse(validus.isphone('123456', 'ro-RO'))
        self.assertFalse(validus.isphone('740123456', 'ro-RO'))
        self.assertFalse(validus.isphone('+40640123456', 'ro-RO'))
        self.assertFalse(validus.isphone('+40210123456', 'ro-RO'))

        self.assertTrue(validus.isphone('0811 778 998', 'id-ID'))
        self.assertTrue(validus.isphone('089931236181900', 'id-ID'))
        self.assertTrue(validus.isphone('622178878890', 'id-ID'))
        self.assertTrue(validus.isphone('62811 778 998', 'id-ID'))
        self.assertTrue(validus.isphone('62811778998', 'id-ID'))
        self.assertFalse(validus.isphone('123456', 'id-ID'))
        self.assertFalse(validus.isphone('740123456', 'id-ID'))
        self.assertFalse(validus.isphone('+65640123456', 'id-ID'))
        self.assertFalse(validus.isphone('+64210123456', 'id-ID'))

        self.assertTrue(validus.isphone('01711 123456', 'bn-BD'))
        self.assertTrue(validus.isphone('01711-123456', 'bn-BD'))
        self.assertTrue(validus.isphone('01711123456', 'bn-BD'))
        self.assertTrue(validus.isphone('+8801711 123456', 'bn-BD'))
        self.assertTrue(validus.isphone('+8801711-123456', 'bn-BD'))
        self.assertTrue(validus.isphone('+8801711123456', 'bn-BD'))
        self.assertTrue(validus.isphone('8801711 123456', 'bn-BD'))
        self.assertTrue(validus.isphone('8801711-123456', 'bn-BD'))
        self.assertTrue(validus.isphone('8801711123456', 'bn-BD'))
        self.assertFalse(validus.isphone('8801711123456789', 'bn-BD'))
        self.assertFalse(validus.isphone('17111234567', 'bn-BD'))
        self.assertFalse(validus.isphone('017111234567', 'bn-BD'))
        self.assertFalse(validus.isphone('Vml2YW11cyBmZXJtZtesting123', 'bn-BD'))
        self.assertFalse(validus.isphone('+881711234567', 'bn-BD'))
        self.assertFalse(validus.isphone('0171112345', 'bn-BD'))
        self.assertFalse(validus.isphone('0171112345', 'bn-BD'))
        self.assertFalse(validus.isphone('01711 12345', 'bn-BD'))
        self.assertFalse(validus.isphone('01711-12345', 'bn-BD'))
        self.assertFalse(validus.isphone('017-112345', 'bn-BD'))
        